unit MainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, RBBar, ExtCtrls, StdCtrls, FileCtrl, Menus, Spin, ActnList,
  ExtDlgs, ShellAPI;

type
  TMainForm = class(TForm)
    Bar: TRBBar;
    LargeImageList: TImageList;
    SmallImageList: TImageList;
    Splitter: TSplitter;
    BarPopupMenu: TPopupMenu;
    LargeIconsPMI: TMenuItem;
    SmallIconsPMI: TMenuItem;
    MainActionList: TActionList;
    AddGroupAction: TAction;
    RemoveGroupAction: TAction;
    RenameGroupAction: TAction;
    AddGroupPMI: TMenuItem;
    LargeIconsAction: TAction;
    SmallIconsAction: TAction;
    RemoveGroupPMI: TMenuItem;
    GroupDividerPMI: TMenuItem;
    RenameGroupPMI: TMenuItem;
    RenameItemAction: TAction;
    RenameItemPMI: TMenuItem;
    RemoveItemAction: TAction;
    RemoveItemPMI: TMenuItem;
    InfoPanel: TPanel;
    DragAndDropGroupBox: TGroupBox;
    DragDropLabel: TLabel;
    DriveComboBox: TDriveComboBox;
    DirectoryListBox: TDirectoryListBox;
    AppearanceGroupBox: TGroupBox;
    AnimationLabel: TLabel;
    CaptionHeightLabel: TLabel;
    AnimationSpeedLabel: TLabel;
    FlatBorderCheckBox: TCheckBox;
    AnimationComboBox: TComboBox;
    CaptionHeightSpinEdit: TSpinEdit;
    AnimationSpeedSpinEdit: TSpinEdit;
    RTLCheckBox: TCheckBox;
    CustomDrawCheckBox: TCheckBox;
    InfoLabel: TLabel;
    CaptionImageList: TImageList;
    AlignmentRadioGroup: TRadioGroup;
    CaptionColorAction: TAction;
    ColorDialog: TColorDialog;
    GroupDivider2PMI: TMenuItem;
    CaptionColorPMI: TMenuItem;
    GroupColorAction: TAction;
    GroupGradientAction: TAction;
    GroupBitmapAction: TAction;
    BackgroundPMI: TMenuItem;
    GroupColorPMI: TMenuItem;
    GroupGradientPMI: TMenuItem;
    GroupBitmapPMI: TMenuItem;
    OpenPictureDialog: TOpenPictureDialog;
    LogoPanel: TPanel;
    LogoImage: TImage;
    WebLabel: TLabel;
    URLLabel: TLabel;
    procedure DirectoryListBoxStartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure FlatBorderCheckBoxClick(Sender: TObject);
    procedure AnimationComboBoxChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CaptionHeightSpinEditChange(Sender: TObject);
    procedure AnimationSpeedSpinEditChange(Sender: TObject);
    procedure RTLCheckBoxClick(Sender: TObject);
    procedure AddGroupActionExecute(Sender: TObject);
    procedure AddGroupActionUpdate(Sender: TObject);
    procedure LargeIconsActionUpdate(Sender: TObject);
    procedure SmallIconsActionUpdate(Sender: TObject);
    procedure LargeIconsActionExecute(Sender: TObject);
    procedure SmallIconsActionExecute(Sender: TObject);
    procedure RemoveGroupActionExecute(Sender: TObject);
    procedure RemoveGroupActionUpdate(Sender: TObject);
    procedure RenameGroupActionExecute(Sender: TObject);
    procedure RenameGroupActionUpdate(Sender: TObject);
    procedure RenameItemActionExecute(Sender: TObject);
    procedure RenameItemActionUpdate(Sender: TObject);
    procedure RemoveItemActionUpdate(Sender: TObject);
    procedure RemoveItemActionExecute(Sender: TObject);
    procedure BarItemClick(Sender: TObject; Item: TRBBarItem);
    procedure CustomDrawCheckBoxClick(Sender: TObject);
    procedure BarDrawGroupCaption(Sender: TObject; Canvas: TCanvas;
      Group: TRBBarGroup; CaptionRect: TRect; State: TRBBGroupState);
    procedure AlignmentRadioGroupClick(Sender: TObject);
    procedure CaptionColorActionExecute(Sender: TObject);
    procedure GroupBackActionUpdate(Sender: TObject);
    procedure GroupColorActionExecute(Sender: TObject);
    procedure GroupGradientActionExecute(Sender: TObject);
    procedure GroupBitmapActionExecute(Sender: TObject);
    procedure URLLabelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.DirectoryListBoxStartDrag(Sender: TObject;
  var DragObject: TDragObject);
var
  drag_object : TRBBarDragItem;
begin
  drag_object := TRBBarDragItem.Create;
  drag_object.Item := TRBBarItem.Create ( nil );

  drag_object.Item.Caption := DirectoryListBox.Items [ DirectoryListBox.ItemIndex ];
  drag_object.Item.ImageIndex := 3;
  drag_object.Item.OverImageIndex := 3;  
  DragObject := drag_object;
end;

procedure TMainForm.FlatBorderCheckBoxClick(Sender: TObject);
begin
  if FlatBorderCheckBox.Checked then
    Bar.FlatBorder := True
  else
  begin
    Bar.FlatBorder := False;
    Bar.Ctl3D := True;
  end;
end;

procedure TMainForm.AnimationComboBoxChange(Sender: TObject);
begin
  Bar.AnimationStyle := TRBBAnimationStyle ( AnimationComboBox.ItemIndex );
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  AnimationComboBox.ItemIndex := 2;
  CaptionHeightSpinEdit.Value := 20;
  AnimationSpeedSpinEdit.Value := Bar.AnimationSpeed;
end;

procedure TMainForm.CaptionHeightSpinEditChange(Sender: TObject);
begin
  Bar.GroupCaptionHeight := CaptionHeightSpinEdit.Value;
end;

procedure TMainForm.AnimationSpeedSpinEditChange(Sender: TObject);
begin
  Bar.AnimationSpeed := AnimationSpeedSpinEdit.Value;
end;

procedure TMainForm.RTLCheckBoxClick(Sender: TObject);
begin
  if RTLCheckBox.Checked then Bar.BiDiMode := bdRightToLeft
  else Bar.BiDiMode := bdLeftToRight;
end;

procedure TMainForm.AddGroupActionExecute(Sender: TObject);
begin
  Bar.EditNewGroup ( 'New group' );
end;

procedure TMainForm.AddGroupActionUpdate(Sender: TObject);
begin
  AddGroupAction.Visible := ( Bar.ItemUnderCursor = nil );
end;

procedure TMainForm.LargeIconsActionUpdate(Sender: TObject);
begin
  LargeIconsAction.Visible := ( Bar.ItemUnderCursor = nil ) and
                              ( Bar.VisibleGroupObject <> nil );

  GroupDividerPMI.Visible := LargeIconsAction.Visible;
  GroupDivider2PMI.Visible := LargeIconsAction.Visible;
  BackgroundPMI.Visible := LargeIconsAction.Visible;

  if Bar.VisibleGroupObject = nil then Exit;
  if Bar.VisibleGroupObject.ImageSize = isLarge then
  begin
    LargeIconsAction.Checked := True;
    SmallIconsAction.Checked := False;
  end;
end;

procedure TMainForm.SmallIconsActionUpdate(Sender: TObject);
begin
  SmallIconsAction.Visible := ( Bar.ItemUnderCursor = nil ) and
                              ( Bar.VisibleGroupObject <> nil );
  if Bar.VisibleGroupObject = nil then Exit;
  if Bar.VisibleGroupObject.ImageSize = isSmall then
  begin
    LargeIconsAction.Checked := False;
    SmallIconsAction.Checked := True;
  end;
end;

procedure TMainForm.LargeIconsActionExecute(Sender: TObject);
begin
  LargeIconsAction.Checked := True;
  SmallIconsAction.Checked := False;
  Bar.VisibleGroupObject.ImageSize := isLarge;
end;

procedure TMainForm.SmallIconsActionExecute(Sender: TObject);
begin
  LargeIconsAction.Checked := False;
  SmallIconsAction.Checked := True;
  Bar.VisibleGroupObject.ImageSize := isSmall;
end;

procedure TMainForm.RemoveGroupActionExecute(Sender: TObject);
var
  group : TRBBarGroup;
begin
  if Bar.GroupUnderCursor = nil then group := Bar.VisibleGroupObject
  else group := Bar.GroupUnderCursor;

  if MessageDlg ( 'Are you sure you want to remove the "' +
                  group.Caption + '" group?' ,
                  mtConfirmation , [mbYes, mbNo] , 0 ) = mrYes then
    group.Delete;
end;

procedure TMainForm.RemoveGroupActionUpdate(Sender: TObject);
begin
  RemoveGroupAction.Visible := ( Bar.ItemUnderCursor = nil ) and
                               ( Bar.VisibleGroupObject <> nil );
end;

procedure TMainForm.RenameGroupActionExecute(Sender: TObject);
begin
  if Bar.GroupUnderCursor = nil then Bar.VisibleGroupObject.Edit
  else Bar.GroupUnderCursor.Edit;
end;

procedure TMainForm.RenameGroupActionUpdate(Sender: TObject);
begin
  RenameGroupAction.Visible := ( Bar.ItemUnderCursor = nil ) and
                               ( Bar.VisibleGroupObject <> nil );
end;

procedure TMainForm.RenameItemActionExecute(Sender: TObject);
begin
  Bar.ItemUnderCursor.Edit;
end;

procedure TMainForm.RenameItemActionUpdate(Sender: TObject);
begin
  RenameItemAction.Visible := ( Bar.ItemUnderCursor <> nil );
end;

procedure TMainForm.RemoveItemActionUpdate(Sender: TObject);
begin
  RemoveItemAction.Visible := ( Bar.ItemUnderCursor <> nil );
end;

procedure TMainForm.RemoveItemActionExecute(Sender: TObject);
begin
  Bar.ItemUnderCursor.Delete;
end;

procedure TMainForm.BarItemClick(Sender: TObject; Item: TRBBarItem);
begin
  MessageDlg ( 'You clicked on the item "' + Item.Caption +
               '" in the group "' + Item.Group.Caption + '"!', mtInformation, [mbOK], 0);
end;

procedure TMainForm.CustomDrawCheckBoxClick(Sender: TObject);
begin
  Bar.CustomDrawGroupCaption := CustomDrawCheckBox.Checked;
  if Bar.CustomDrawGroupCaption then
    Bar.GroupCaptionHeight := CaptionImageList.Height;
end;

procedure TMainForm.BarDrawGroupCaption(Sender: TObject; Canvas: TCanvas;
  Group: TRBBarGroup; CaptionRect: TRect; State: TRBBGroupState);
var
  w , x : integer;
  r : TRect;
  flags : LongInt;
begin
  with Canvas do
  begin
    w := CaptionImageList.Width;
    CaptionImageList.Draw ( Canvas , CaptionRect.Left , CaptionRect.Top , 0 );
    x := CaptionRect.Left + w;
    repeat
      CaptionImageList.Draw ( Canvas , x , CaptionRect.Top , 1 );
      Inc ( x , w );
    until x >= CaptionRect.Right;
    CaptionImageList.Draw ( Canvas , CaptionRect.Right - w , CaptionRect.Top , 2 );
    r := Rect ( CaptionRect.Left + w + 1 , CaptionRect.Top + 10 ,
                CaptionRect.Right - w + 4 , CaptionRect.Top + 24 );

    flags := Bar.DrawTextBiDiModeFlags ( DT_NOPREFIX or DT_CENTER or DT_VCENTER or
                                         DT_SINGLELINE or DT_END_ELLIPSIS );
    Font := Bar.GroupsFont;
    Brush.Style := bsClear;
    DrawText ( Handle , PChar(Group.Caption) , Length ( Group.Caption) ,
               r , flags );

    Brush.Style := bsSolid;
    Brush.Color := Group.CaptionColor;
    r := Rect ( CaptionRect.Left + 11 , CaptionRect.Top + 13 ,
                CaptionRect.Left+19 , CaptionRect.Top + 20 );
    FillRect ( r );
  end;
end;

procedure TMainForm.AlignmentRadioGroupClick(Sender: TObject);
begin
  if AlignmentRadioGroup.ItemIndex = 0 then
  begin
    Splitter.Align := alLeft;
    Bar.Alignment := baVertical;
    Bar.Align := alLeft;
    Bar.Width := 90;
    Bar.CustomDrawGroupCaption := False;
    CustomDrawCheckBox.Enabled := True;
    CustomDrawCheckBox.Checked := False;
  end
  else
  begin
    Bar.Alignment := baHorizontal;
    Bar.Align := alTop;
    Bar.Height := 90;
    Splitter.Align := alTop;
    Bar.CustomDrawGroupCaption := False;    
    CustomDrawCheckBox.Enabled := False;
    CustomDrawCheckBox.Checked := False;
  end;
end;

procedure TMainForm.CaptionColorActionExecute(Sender: TObject);
var
  group : TRBBarGroup;
begin
  if Bar.GroupUnderCursor = nil then group := Bar.VisibleGroupObject
  else group := Bar.GroupUnderCursor;

  ColorDialog.Color := group.CaptionColor;
  if ColorDialog.Execute then group.CaptionColor := ColorDialog.Color;
end;

procedure TMainForm.GroupBackActionUpdate(Sender: TObject);
begin
  ( Sender as TAction ).Visible := ( Bar.ItemUnderCursor = nil ) and
                                   ( Bar.VisibleGroupObject <> nil );
end;

procedure TMainForm.GroupColorActionExecute(Sender: TObject);
var
  group : TRBBarGroup;
begin
  if Bar.GroupUnderCursor = nil then group := Bar.VisibleGroupObject
  else group := Bar.GroupUnderCursor;

  ColorDialog.Color := group.Color;
  if ColorDialog.Execute then
  begin
    group.Color := ColorDialog.Color;
    group.Style := gbColor;
  end;
end;

procedure TMainForm.GroupGradientActionExecute(Sender: TObject);
var
  group : TRBBarGroup;
  start_color , end_color : TColor;
begin
  if Bar.GroupUnderCursor = nil then group := Bar.VisibleGroupObject
  else group := Bar.GroupUnderCursor;

  MessageDlg('Please select first color', mtInformation, [mbOK], 0);
  ColorDialog.Color := group.StartColor;
  if not ColorDialog.Execute then Exit;
  start_color := ColorDialog.Color;

  MessageDlg('Please select second color', mtInformation, [mbOK], 0);
  if not ColorDialog.Execute then Exit;
  end_color := ColorDialog.Color;

  group.StartColor := start_color;
  group.EndColor := end_color;
  group.Style := gbGradient;
end;

procedure TMainForm.GroupBitmapActionExecute(Sender: TObject);
var
  group : TRBBarGroup;
begin
  if Bar.GroupUnderCursor = nil then group := Bar.VisibleGroupObject
  else group := Bar.GroupUnderCursor;

  if OpenPictureDialog.Execute then
  begin
    group.Bitmap.LoadFromFile ( OpenPictureDialog.FileName );
    group.Style := gbBitmap;
    Bar.Invalidate;
  end;
end;

procedure TMainForm.URLLabelClick(Sender: TObject);
begin
  ShellExecute ( 0 , 'open' , 'http://www.borshack.com' , nil , nil ,
                 SW_SHOWNORMAL);
end;

end.
